BEP Support
===========

| Symbol   | Meaning                     |
|:--------:|-----------------------------|
| &#x2705; | Supported                   |
| &#x274C; | Unsupported (link to issue) |
| &#x2796; | Not Applicable              |

<br>

| BEP                                            | Status                                                     | Title                                                            |
|:----------------------------------------------:|:----------------------------------------------------------:|:-----------------------------------------------------------------|
| [00](http://bittorrent.org/beps/bep_0000.html) | &#x2796;                                                   | Index of BitTorrent Enhancement Proposals                        |
| [01](http://bittorrent.org/beps/bep_0001.html) | &#x2796;                                                   | The BitTorrent Enhancement Proposal Process                      |
| [02](http://bittorrent.org/beps/bep_0002.html) | &#x2796;                                                   | Sample reStructured Text BEP Template                            |
| [03](http://bittorrent.org/beps/bep_0003.html) | &#x2705;                                                   | The BitTorrent Protocol Specification                            |
| [04](http://bittorrent.org/beps/bep_0004.html) | &#x2796;                                                   | Assigned Numbers                                                 |
| [05](http://bittorrent.org/beps/bep_0005.html) | &#x2705;                                                   | DHT Protocol                                                     |
| [06](http://bittorrent.org/beps/bep_0006.html) | &#x2796;                                                   | Fast Extension                                                   |
| [07](http://bittorrent.org/beps/bep_0007.html) | &#x2796;                                                   | IPv6 Tracker Extension                                           |
| [08](http://bittorrent.org/beps/bep_0008.html) | &#x2796;                                                   | Tracker Peer Obfuscation                                         |
| [09](http://bittorrent.org/beps/bep_0009.html) | &#x2705;                                                   | Extension for Peers to Send Metadata Files                       |
| [10](http://bittorrent.org/beps/bep_0010.html) | &#x2796;                                                   | Extension Protocol                                               |
| [11](http://bittorrent.org/beps/bep_0011.html) | &#x2796;                                                   | Peer Exchange (PEX)                                              |
| [12](http://bittorrent.org/beps/bep_0012.html) | &#x2705;                                                   | Multitracker Metadata Extension                                  |
| [14](http://bittorrent.org/beps/bep_0014.html) | &#x2796;                                                   | Local Service Discovery                                          |
| [15](http://bittorrent.org/beps/bep_0015.html) | &#x2796;                                                   | UDP Tracker Protocol for BitTorrent                              |
| [16](http://bittorrent.org/beps/bep_0016.html) | &#x2796;                                                   | Superseeding                                                     |
| [17](http://bittorrent.org/beps/bep_0017.html) | [&#x274C;](https://github.com/casey/intermodal/issues/92)  | HTTP Seeding                                                     |
| [18](http://bittorrent.org/beps/bep_0018.html) | &#x2796;                                                   | Search Engine Specificiation                                     |
| [19](http://bittorrent.org/beps/bep_0019.html) | [&#x274C;](https://github.com/casey/intermodal/issues/93)  | WebSeed - HTTP/FTP Seeding (GetRight style)                      |
| [20](http://bittorrent.org/beps/bep_0020.html) | &#x2796;                                                   | Peer ID Conventions                                              |
| [21](http://bittorrent.org/beps/bep_0021.html) | &#x2796;                                                   | Extension for partial seeds                                      |
| [22](http://bittorrent.org/beps/bep_0022.html) | &#x2796;                                                   | BitTorrent Local Tracker Discovery Protocol                      |
| [23](http://bittorrent.org/beps/bep_0023.html) | &#x2796;                                                   | Tracker Returns Compact Peer Lists                               |
| [24](http://bittorrent.org/beps/bep_0024.html) | &#x2796;                                                   | Tracker Returns External IP                                      |
| [25](http://bittorrent.org/beps/bep_0025.html) | &#x2796;                                                   | An Alternate BitTorrent Cache Discovery Protocol                 |
| [26](http://bittorrent.org/beps/bep_0026.html) | &#x2796;                                                   | Zeroconf Peer Advertising and Discovery                          |
| [27](http://bittorrent.org/beps/bep_0027.html) | &#x2705;                                                   | Private Torrents                                                 |
| [28](http://bittorrent.org/beps/bep_0028.html) | &#x2796;                                                   | Tracker exchange extension                                       |
| [29](http://bittorrent.org/beps/bep_0029.html) | &#x2796;                                                   | uTorrent transport protocol                                      |
| [30](http://bittorrent.org/beps/bep_0030.html) | [&#x274C;](https://github.com/casey/intermodal/issues/94)  | Merkle hash torrent extension                                    |
| [31](http://bittorrent.org/beps/bep_0031.html) | &#x2796;                                                   | Failure Retry Extension                                          |
| [32](http://bittorrent.org/beps/bep_0032.html) | &#x2796;                                                   | BitTorrent DHT Extensions for IPv6                               |
| [33](http://bittorrent.org/beps/bep_0033.html) | &#x2796;                                                   | DHT Scrapes                                                      |
| [34](http://bittorrent.org/beps/bep_0034.html) | &#x2796;                                                   | DNS Tracker Preferences                                          |
| [35](http://bittorrent.org/beps/bep_0035.html) | [&#x274C;](https://github.com/casey/intermodal/issues/96)  | Torrent Signing                                                  |
| [36](http://bittorrent.org/beps/bep_0036.html) | &#x2796;                                                   | Torrent RSS feeds                                                |
| [37](http://bittorrent.org/beps/bep_0037.html) | &#x2796;                                                   | Anonymous BitTorrent over proxies                                |
| [38](http://bittorrent.org/beps/bep_0038.html) | &#x2796;                                                   | Finding Local Data Via Torrent File Hints                        |
| [39](http://bittorrent.org/beps/bep_0039.html) | [&#x274C;](https://github.com/casey/intermodal/issues/98)  | Updating Torrents Via Feed URL                                   |
| [40](http://bittorrent.org/beps/bep_0040.html) | &#x2796;                                                   | Canonical Peer Priority                                          |
| [41](http://bittorrent.org/beps/bep_0041.html) | &#x2796;                                                   | UDP Tracker Protocol Extensions                                  |
| [42](http://bittorrent.org/beps/bep_0042.html) | &#x2796;                                                   | DHT Security extension                                           |
| [43](http://bittorrent.org/beps/bep_0043.html) | &#x2796;                                                   | Read-only DHT Nodes                                              |
| [44](http://bittorrent.org/beps/bep_0044.html) | &#x2796;                                                   | Storing arbitrary data in the DHT                                |
| [45](http://bittorrent.org/beps/bep_0045.html) | &#x2796;                                                   | Multiple-address operation for the BitTorrent DHT                |
| [46](http://bittorrent.org/beps/bep_0046.html) | [&#x274C;](https://github.com/casey/intermodal/issues/244) | Updating Torrents Via DHT Mutable Items                          |
| [47](http://bittorrent.org/beps/bep_0047.html) | [&#x274C;](https://github.com/casey/intermodal/issues/99)  | Padding files and extended file attributes                       |
| [48](http://bittorrent.org/beps/bep_0048.html) | &#x2796;                                                   | Tracker Protocol Extension: Scrape                               |
| [49](http://bittorrent.org/beps/bep_0049.html) | [&#x274C;](https://github.com/casey/intermodal/issues/100) | Distributed Torrent Feeds                                        |
| [50](http://bittorrent.org/beps/bep_0050.html) | &#x2796;                                                   | Publish/Subscribe Protocol                                       |
| [51](http://bittorrent.org/beps/bep_0051.html) | &#x2796;                                                   | DHT Infohash Indexing                                            |
| [52](http://bittorrent.org/beps/bep_0052.html) | [&#x274C;](https://github.com/casey/intermodal/issues/101) | The BitTorrent Protocol Specification v2                         |
| [53](http://bittorrent.org/beps/bep_0053.html) | [&#x274C;](https://github.com/casey/intermodal/issues/245) | Magnet URI extension - Select specific file indices for download |
| [54](http://bittorrent.org/beps/bep_0054.html) | &#x2796;                                                   | The lt_donthave extension                                        |
| [55](http://bittorrent.org/beps/bep_0055.html) | &#x2796;                                                   | Holepunch extension                                              |
